package souběh;

// Souběh odstraněn pomocí synchronizace vlastním zámkem

import static java.lang.Math.*;
import javax.swing.JOptionPane;

public class Přepravka 
{
    public double x, y, z;
    private long početDodávek = 0;
    private final Object zámek = new Object();
    public Přepravka()
    {
        this.x = 1;
        this.y = 0;
        this.z = 0;
    }
    
    public void přijmiPodklady(double gama1, double gama2)
    {
        double costheta = 2*gama1 - 1;
        double fí = 2*gama2*PI;
        double sintheta = sqrt(1 - costheta*costheta);
        synchronized (zámek) 
        {
            x = sintheta*cos(fí);
            y = sintheta*sin(fí);
            z = costheta;   
        }
        početDodávek++;
    }
    
    public void kontrola()
    {
        //System.out.println(abs(x*x + y*y + z*z - 1));
        if(abs(x*x + y*y + z*z - 1) > 1e-10)
        {
            javax.swing.JOptionPane.showMessageDialog(null, "Nekonzistence dat po " + početDodávek + " dodávkách.", "Končíme", JOptionPane.INFORMATION_MESSAGE);
            System.exit(0);
        }
    }
    
    @Override
    public String toString()
    {
        //kontrola();  // Nyní zbytečné
        synchronized(zámek)
        {
            return "(" + x + ", " + y + ", " + z + ")";
        }
    }
    
    public String data()
    {
        return toString();
    }
}
