package čas;

import java.util.ArrayList;

public class Časovač implements Runnable
{
    public Časovač(int interval)
    {
        this.interval = interval;
        vlákno = new Thread(this);
        vlákno.setDaemon(true);
        vlákno.start();
    }
    public Časovač()
    {
        this(500);
    }
    
    public void přidejPosluchače(PosluchačČasovače posluchač)
    {
        posluchači.add(posluchač);
    }
    public  void odstraňPosluchače(PosluchačČasovače posluchač)
    {
        posluchači.remove(posluchač);
    }
    
    public boolean jePovolen()
    {
        return povoleno;
    }
    
    public synchronized void nastavPovolení(boolean povolTo)
    {
        povoleno = povolTo;
        if(povolTo) notify();
    }
    
    private void odpalTo()
    {
        if(!posluchači.isEmpty())
        {
            //posluchači.forEach((posluchač)->{posluchač.probuzení(new UdálostČasovače(this))});
            for(var posluchač: posluchači)
            {
                posluchač.probuzení(new UdálostČasovače(this));
            }
        }
    }
    
    @Override
    public void run() 
    {
        while(true)
        {
            try
            {
                odpalTo();
                Thread.sleep(interval);
                synchronized (this) 
                {
                    while(!povoleno) wait();
                }
            }
            catch(InterruptedException e)
            {
                // Úmyslně prázdná obsluha
            }
        }
    }
    
    private int interval;
    private boolean povoleno = false;
    private ArrayList<PosluchačČasovače> posluchači = new ArrayList<>();
    private Thread vlákno;
}
